Attribute VB_Name = "Handler"
Option Explicit

Public Sub ACList(TextX As TextBox, ListX As ListBox, KeyAscii As Integer, Locked As Boolean)
'This is a modified version of code that was modified by Jackie.
'The extra 'Locked' variable allows us to either add items as we go (Locked = False) or only use the items
'that are already in the list (Locked = True).
    Dim lCnt       As Long 'Generic long counter
    Dim lMax       As Long
    Dim sComboItem As String
    Dim sComboText As String 'Text currently in combobox
    Dim sText      As String 'Text after keypressed
    Dim miSelStart As Integer
    'MsgBox KeyAscii
    
    miSelStart = TextX.SelStart 'Set the entry point of the selected text
    If KeyAscii = 13 Or KeyAscii = 27 Then Exit Sub 'Carriage Return or escape
    
    With ListX

        lMax = .ListCount - 1 'The number of values in the list
        sComboText = TextX.Text 'The current text in the list
 '       TextX.Text = .Text
        
        '**********************************************
        'This block either removes or adds a character
        '***********************************************
        If KeyAscii = 8 Then 'Backspace
            'If there is one character left, remove the text
            If Len(TextX.Text) = 1 Or Len(TextX.Text) = 0 Then
                TextX.Text = ""
                miSelStart = 0
                Exit Sub
            'There is one character and seltext (our matched text)
            ElseIf Len(TextX.Text) - (Len(TextX.Text) - miSelStart) = 1 Then
                TextX.Text = ""
                miSelStart = 0
                Exit Sub
            End If
            
            'An ordinary backspace, decrement 1 character
            TextX.Text = Left(sComboText, miSelStart - 1)
            sText = Left(sComboText, miSelStart - 1) 'reset our sText var sText = combo1.text??
        Else
            'A char other than backspace, return or escape was pressed
            sText = Left(sComboText, miSelStart) & Chr(KeyAscii) 'Increment our string with the new char
        End If

        KeyAscii = 0 'Reset key pressed
        
        '**********************************************
        'This block performs our lookup
        '**********************************************
        For lCnt = 0 To lMax
            sComboItem = .List(lCnt) 'Current item
            
            If UCase(sText) = UCase(Left(sComboItem, _
                                         Len(sText))) Then 'A match was found
                '.ListIndex = lCnt 'Not sure why this is needed
                TextX.Text = sComboItem
                .Text = sComboItem
                TextX.SelStart = Len(sText) 'Start the highlighting after manually entered text
                TextX.SelLength = Len(sComboItem) - (Len(sText)) 'Highlight to the end of the text
                NewName = False
                .Visible = True   'If your item is in the list, make the list visible.
                Exit For
            Else
                If Locked = False Then
                    TextX.Text = sText 'Set the text value = the new text
                    TextX.SelStart = Len(TextX.Text) 'Set selstart to the end of the string
                    If TextX.Text > "" Then
                        NewName = True
                    Else
                        NewName = False
                    End If
                Else
                    If Len(TextX.Text) > 0 Then TextX.Text = Left$(TextX.Text, Len(TextX.Text) - 1)
                    If Len(TextX.Text) > 0 Then
                        TextX.SelStart = Len(TextX.Text) 'Set selstart to the end of the string
                    End If
                End If
                .Visible = False 'If the item is not in the list then make it invisible.
            End If
        Next lCnt
        End With


End Sub

Public Sub HandleKCode(ListX As ListBox, TextX As TextBox, kc As Integer)
'This subroutine recognises the up and down keys and sets the selected item in the list
'according to your position.
    If kc = 38 Then 'up
        kc = 0
        If ListX.ListIndex > 0 Then
            ListX.ListIndex = ListX.ListIndex - 1
            TextX.Text = ListX.Text
        End If
    End If
    If kc = 40 Then 'down
        kc = 0
        If ListX.ListIndex < ListX.ListCount - 1 Then
            ListX.ListIndex = ListX.ListIndex + 1
            TextX.Text = ListX.Text
        End If
    End If
End Sub

